#============================================================================================================================================#
# -*- coding:Utf-8 -*-
# say_sound V1.2p (29/01/2008) by DoCky 
# MATTIE'S EVENTSCRIPTS 2.0, PYTHON OPERATIONNEL




import es, os, psyco, keyvalues as _ke, popuplib as _po , ConfigParser as _co, random as _ra, playerlib as _pl
from FileAnalyse import FileAnalyse as _an
from BuildMenu import BuildMenu as _bu
psyco.full()

ss_info = es.AddonInfo()
ss_info.version = "1.2p"
ss_info.author = "DoCky"
ss_info.name = "say_sound"
ss_info.url = "http://addons.eventscripts.com/addons/user/11751"

ss_game = {
    "Counter-Strike: Source" : "/cstrike",
    "Day of Defeat: Source" : "/dod",
    "Day of Defeat" : "/dod",
    "Half-Life 2 Deathmatch" : "/hl2mp",
    "Deathmatch" : "/hl2mp"
    }

ss_path = os.getcwd() + ss_game[es.getgame()] + "/cfg/say_sound/"



#    SYSTEM    #
class System:
    """
        Script system
    """

    _lang = es.ServerVar("ss_lang")
    _down = es.ServerVar("ss_down")
    _user = es.ServerVar("ss_user")
    _volu = es.ServerVar("ss_volu")
    _menu = es.ServerVar("ss_menu")
    _play = es.ServerVar("ss_play")
    _maxi = es.ServerVar("ss_maxi")

    _keys = _ke.KeyValues(name="ss_list")
    _conf = None
    _list = []
    _file = []
    _dele = []
    _info = {}
    _used = {}


    @staticmethod
    def loadConf():
        if not os.path.isfile(ss_path + "config.cfg"):
            es.log("[say_sound] missing file : cfg/say_sound/config.cfg")

        else:
            es.ServerVar(ss_info.name, ss_info.version, "version actuelle du script").makepublic()
            es.ForceServerCommand("es_xmexec ../cfg/say_sound/config.cfg")

            System._conf = _co.ConfigParser()
            es.log("[say_sound] config loaded")

            System.keyGroup()
            System.makeLang()

            if System._info and System._info != "0":
                if System._dele:
                    System.deleMenu()

                System.makeMenu(System._list)
                es.log("[say_sound] menu created")

            System.downLoad()


    @staticmethod
    def keyGroup():
        if not os.path.isfile(ss_path + "ss_list.txt"):
            es.log("[say_sound] missing file : cfg/say_sound/ss_list.txt")
            es.log("[say_sound] file created : you must edit it")

            System._keys["my word"] = _ke.KeyValues(name="my word")
            System._keys["my word"]["1"] = "EDIT : my file/my sound 1.mp3"
            System._keys.save("cfg/say_sound/ss_list.txt")

        else:
            System._keys.load("cfg/say_sound/ss_list.txt")

            for word in System._keys:
                if word.keys():

                    if not word.getName() in System._list:
                        System._list.append(word.getName())

                    for path in word.keys():
                        System._file.append("sound/" + System._keys[word.getName()][path])


    @staticmethod
    def makeLang():
        for line in _an(ss_path + "language/" + System._lang + ".cfg").getList():
            info = line.split("=")

            if len(info) == 2:
                System._info[info[0].strip()] = info[1].strip()

        if len(System._info) != 4:
            es.log("[say_sound] corrupt file : cfg/say_sound/language.cfg")


    @staticmethod
    def makeMenu(word):
        indp = 0
        numb = len(word)
        page = _bu.getPage(numb, 7)

        while indp < page:
            name = "ss_menu_%s" % str(indp)
            System._conf.add_section(name)
            System._dele.append(name)

            menu = _po.create(name)
            menu.addline("%s :    %s/%s" % (System._info["ss_tittle_menu"], str(indp + 1), str(page)))

            item = _bu.getItem(indp + 1, page, numb, 7)
            indi = 0

            while indi < item:
                menu.addline("->%s. %s" % (str(indi + 1), str(word[indi])))
                System._conf.set(name, str(indi + 1), str(word[indi]))
                indi += 1

            if indp + 1 < page:
                menu.addline("8. Next")
                menu.submenu(8, "ss_menu_%s" % (str(indp + 1)))

            if indp and indp < page:
                menu.addline("9. Back")
                menu.submenu(9, "ss_menu_%s" % (str(indp - 1)))

            menu.addline("0. Exit")
            indp += 1

            if int(System._play):
                menu.menuselect = sound_menu


    @staticmethod
    def deleMenu():
        for menu in System._dele:
            if _po.exists(menu):
                _po.delete(menu)


    @staticmethod
    def downLoad():
        if int(System._down):
            es.log("[say_sound] files will be downloaded")

            for path in System._file:
                es.stringtable("downloadables", path)


    @staticmethod
    def selePath(text):
        return System._keys[text][str(_ra.randint(1, len(System._keys[text].keys())))]




#    EVENT    #
def load():
    System.loadConf()


def unload():
    System.deleMenu()


def es_map_start(event_var):
    System.loadConf()
    System._used = {}


def round_start(evnet_var):
    System._used = {}


def player_say(event_var):
    if event_var["text"] in System._list:
        sound_maxi(int(event_var["userid"]), event_var["text"])

    elif str(event_var["text"]) in str(System._menu).split(","):
        if not _po.exists("ss_menu_0"):

            if System._info["ss_answer_indi"] and System._info["ss_answer_indi"] != "0":
                es.tell(event_var["userid"], "#multi", System._info["ss_answer_indi"])

        else:
            _po.send("ss_menu_0", event_var["userid"])




#    SOUND    #
def sound_menu(userid, choice, popupid):
    item = System._conf.get(popupid, str(choice))

    if item in System._list:
        sound_maxi(userid, item)


def sound_maxi(user, item):
    path = System.selePath(item)
    if int(System._maxi):

        if not System._used.has_key(str(user)):
            System._used[str(user)] = str(System._maxi)

        numb = int(System._used[str(user)])
        if numb:

            System._used[str(user)] = str(numb - 1)
            sound_play(user, path)

            if System._info["ss_answer_rest"] and System._info["ss_answer_rest"] != "0":
                es.tell(user, "#multi", str(System._info["ss_answer_rest"]).replace("%1", str(System._used[str(user)])))

        elif System._info["ss_answer_cant"] and System._info["ss_answer_cant"] != "0":
            es.tell(user, "#multi", System._info["ss_answer_cant"])

    else:
        sound_play(user, path)


def sound_play(user, path):
    if int(System._user):
        es.playsound(user, path, int(System._volu))

    else:
        for huma in _pl.getUseridList("#human"):
            es.playsound(huma, path, int(System._volu))


#============================================================================================================================================#
